'use strict';

exports.__esModule = true;
exports.default = isRequiredIf;

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _createValidator = require('../createValidator');

var _createValidator2 = _interopRequireDefault(_createValidator);

var _valueMissing = require('../internal/valueMissing');

var _valueMissing2 = _interopRequireDefault(_valueMissing);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function isRequiredIf(condition) {
  (0, _invariant2.default)(typeof condition === 'function', 'Please provide a condition function to determine if a field should be required');

  return (0, _createValidator2.default)(function (message) {
    return function (value, allValues) {
      if (condition(allValues) && (0, _valueMissing2.default)(value)) {
        return message;
      }
    };
  }, function (field) {
    return field + ' is required';
  });
}